/*
	s[N[^[&{[\

	XVL^		
					 2006.11.10
						 2006.11.18 
						 2006.11.23 Release
						 2006.11.26 5炢ŉʗsC 47k}ł̃x
	by Kojihaya	

*/


#include "3048f.h"

void initITU(void) ;
void initIO(void) ;

extern	int	iTEST_R;
extern	int	iTEST_L;
extern	int	VOL;
extern	int	ENC;

void	LCD_D0_ASM( unsigned short cnt, unsigned char *dat);
void	LCD_D1_ASM( unsigned short cnt, unsigned char *dat);
void	LCD_PSET0_ASM( unsigned short row, unsigned short xpos );
void	LCD_PSET1_ASM( unsigned short row, unsigned short xpos );
void	GrLCD_COM_WRITE1( unsigned char l);
void	GrLCD_COM_WRITE2( unsigned char l);

GrLCD_END(int l)
{
	if(l){
		GrLCD_COM_WRITE2((char)(0xee));
	} else {
		GrLCD_COM_WRITE1((char)(0xee));
	}
}

const int	P_LEVEL[4][2] = {				/* [^[xωe[u (4iK) */
				{ 512, 4 },
				{  60,10 },
				{ 180, 8 },
				{ 320, 6 },
			};

int	pm_disp = 0;

int	D_LEVEL = 0;

unsigned int	int_count = 0;

void initITU()
{
  ITU0.TCR.BYTE = 0x23 ;    /* clear GRA comparematch,1/8clock  */
  ITU0.TIOR.BYTE = 0 ;      /* not use ITU pins                 */
  ITU0.TIER.BIT.IMIEA = 1 ; /* Enable comparematch-A interrupt  */
  ITU0.GRA = 6249;        /* 2.0ms = 40.0ns * 8 = 320.0ns * 6249  */
  ITU.TSTR.BYTE = 0x01 ;    /* Start ITU ch0                    */

/*	set_ccr(0) ;		*/			/* Clear interrupt mask				*/

}

#pragma interrupt(itime0)
void itime0(void)
{
	int iw;

  ITU0.TSR.BIT.IMFA = 0 ;   /* Stop interrupt request           */

	int_count++;

	if(GetVolumeValue()){	/*@{[l̎擾	*/
		SetAttenuation();	/*@e{[ȟʌvZ	*/
		Send_ATT_Data();	/*@lݒ	f[^𑗐M*/
		LED_DISP2();
		LED_DISP4();
	}

	if( (int_count % 8 ) == 0 ){
		if( iTEST_R > 0 ){
			iTEST_R--;
		}
		if( iTEST_L > 0 ){
			iTEST_L--;
		}
	}

	iw = get_ad4(6) & 0x03ff ;			/* 10bit 0-1023(0V-5V) */

	iw = ( P_LEVEL[D_LEVEL][1] * iw ) - (( P_LEVEL[D_LEVEL][1] * iw / P_LEVEL[D_LEVEL][0]) * iw);
	iw = iw * 100 / P_LEVEL[D_LEVEL][0];
	if( iw > 100 ) iw = 100;

	if( iTEST_R < iw ) iTEST_R = iw;

	iw = get_ad4(7)  & 0x03ff;

	iw = ( P_LEVEL[D_LEVEL][1] * iw ) - (( P_LEVEL[D_LEVEL][1] * iw / P_LEVEL[D_LEVEL][0]) * iw);
	iw = iw * 100 / P_LEVEL[D_LEVEL][0];
	if( iw > 100 ) iw = 100;

	if( iTEST_L < iw ) iTEST_L = iw;

	pm_disp++;	

}

void initIO(void)
{
  PB.DDR = 0x0f ;           /* PB0-3 output , other PB are input*/
}



#define REVERS	1				/* [^[F؂ւ O@AP */

#define	MSX1	0
#define	MSY1	0
#define	MSX2	61
#define	MSY2	0
#define	LOX1	28
#define	LOY1	8
#define	LOX2	61
#define	LOY2	8
#define	PM_Width	56
#define	PM_Height	32


#if REVERS == 0
const unsigned char Peak_meter[PM_Height][PM_Width] = {
	{7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7},
	{7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7},
	{7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7},
	{7,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,7},
	{7,2,7,7,6,7,7,7,7,7,7,6,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,2,7},
	{7,2,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,2,7},
	{7,2,7,7,6,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,6,5,0,1,1,0,1,2,2,2,0,1,2,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,2,7},
	{7,2,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,6,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,2,7},
	{7,2,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,7,7,6,7,7,6,7,7,6,7,7,7,7,7,6,7,7,7,2,7},
	{7,2,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,2,7},
	{7,2,7,7,7,5,0,0,3,7,6,7,0,1,1,7,7,6,0,0,3,7,6,0,0,5,7,6,0,0,2,7,7,7,0,0,7,7,0,5,7,0,2,7,1,2,7,7,1,2,7,5,3,7,2,7},
	{7,2,7,7,7,7,1,2,1,7,7,7,3,1,3,7,7,7,2,1,6,7,6,0,0,7,7,7,0,2,7,7,7,7,5,2,7,7,1,7,7,2,6,7,3,7,7,7,3,7,7,7,7,7,2,7},
	{7,2,7,7,6,7,7,7,4,7,7,7,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,6,2,7},
	{7,2,7,7,7,7,2,3,3,3,4,5,1,4,3,1,5,4,5,5,2,6,1,7,2,7,3,6,5,5,7,3,7,7,3,7,7,2,7,0,4,6,1,0,0,0,0,4,2,5,3,7,7,7,2,7},
	{7,2,7,7,6,4,0,6,5,7,5,7,7,6,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,0,0,0,0,0,0,7,7,6,1,7,7,7,2,7},
	{7,2,7,7,7,7,7,0,2,0,2,0,2,3,1,1,1,1,1,1,1,0,3,2,2,2,3,3,1,3,3,4,3,4,5,4,5,6,4,1,5,2,0,0,0,0,4,6,5,6,7,7,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,2,7},
	{7,2,7,6,7,7,6,7,7,5,2,4,7,3,7,0,5,1,4,4,1,6,3,5,3,4,3,4,3,3,3,4,4,4,4,5,6,4,4,6,6,6,6,6,5,5,3,7,6,7,7,7,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,7},
	{7,2,7,7,6,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,6,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,2,7},
	{7,2,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,7,7,6,7,7,7,7,7,1,1,2,1,0,3,1,7,7,7,7,7,7,6,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,5,5,7,7,7,7,7,6,7,7,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,7},
	{7,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,7},
	{7,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,7},
	{7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7},
	{7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7},
	{7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7}};

#else
const unsigned char Peak_meter[PM_Height][PM_Width] = {
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0},
	{0,2,7,7,6,7,7,7,7,7,7,6,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,2,0},
	{0,2,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,2,0},
	{0,2,7,7,6,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,6,5,0,1,1,0,1,2,2,2,0,1,2,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,2,0},
	{0,2,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,6,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,2,0},
	{0,2,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,7,7,6,7,7,6,7,7,6,7,7,7,7,7,6,7,7,7,2,0},
	{0,2,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,2,0},
	{0,2,7,7,7,5,0,0,3,7,6,7,0,1,1,7,7,6,0,0,3,7,6,0,0,5,7,6,0,0,2,7,7,7,0,0,7,7,0,5,7,0,2,7,1,2,7,7,1,2,7,5,3,7,2,0},
	{0,2,7,7,7,7,1,2,1,7,7,7,3,1,3,7,7,7,2,1,6,7,6,0,0,7,7,7,0,2,7,7,7,7,5,2,7,7,1,7,7,2,6,7,3,7,7,7,3,7,7,7,7,7,2,0},
	{0,2,7,7,6,7,7,7,4,7,7,7,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,6,2,0},
	{0,2,7,7,7,7,2,3,3,3,4,5,1,4,3,1,5,4,5,5,2,6,1,7,2,7,3,6,5,5,7,3,7,7,3,7,7,2,7,0,4,6,1,0,0,0,0,4,2,5,3,7,7,7,2,0},
	{0,2,7,7,6,4,0,6,5,7,5,7,7,6,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,0,0,0,0,0,0,7,7,6,1,7,7,7,2,0},
	{0,2,7,7,7,7,7,0,2,0,2,0,2,3,1,1,1,1,1,1,1,0,3,2,2,2,3,3,1,3,3,4,3,4,5,4,5,6,4,1,5,2,0,0,0,0,4,6,5,6,7,7,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,2,0},
	{0,2,7,6,7,7,6,7,7,5,2,4,7,3,7,0,5,1,4,4,1,6,3,5,3,4,3,4,3,3,3,4,4,4,4,5,6,4,4,6,6,6,6,6,5,5,3,7,6,7,7,7,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,0},
	{0,2,7,7,6,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,6,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,2,0},
	{0,2,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,7,7,6,7,7,7,7,7,1,1,2,1,0,3,1,7,7,7,7,7,7,6,7,7,6,7,7,6,7,7,6,7,7,6,7,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,6,7,5,5,7,7,7,7,7,6,7,7,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,0},
	{0,2,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,2,0},
	{0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};

#endif


const unsigned char Vol_meter[24][10] = {
	{0,0,0,0,0,  0,0,0,0,0},
/*	{5,0,0,0,0,  0,0,0,0,5},	*/
	{0,5,5,5,5,  5,5,5,5,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,3,5,5,5,  5,5,5,3,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,1,5,5,5,  5,5,5,1,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,5,5,5,  5,5,5,0,0},

	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,2,4,4,  4,4,2,0,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,1,4,4,  4,4,1,0,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,0,4,4,  4,4,0,0,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,0,2,4,  4,2,0,0,0},

	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,0,1,2,  2,1,0,0,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,0,0,2,  2,0,0,0,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,0,0,0,1,  1,0,0,0,0},
	{0,0,0,0,0,  0,0,0,0,0},
	{0,7,5,2,1,  1,2,5,7,0}};

const short	PM_LEVEL[38][24] = {			/* X^[gxWɍ킹 */
	{0,0,0,0,0,0,0,0,-19+LOX1,-18+LOX1,-18+LOX1,-17+LOX1,-17+LOX1,-16+LOX1,-15+LOX1,-15+LOX1,-14+LOX1,-14+LOX1,-13+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,-18+LOX1,-17+LOX1,-17+LOX1,-16+LOX1,-16+LOX1,-15+LOX1,-15+LOX1,-14+LOX1,-14+LOX1,-13+LOX1,-12+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,-17+LOX1,-16+LOX1,-16+LOX1,-15+LOX1,-15+LOX1,-14+LOX1,-14+LOX1,-13+LOX1,-13+LOX1,-12+LOX1,-12+LOX1,-11+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,-16+LOX1,-16+LOX1,-15+LOX1,-15+LOX1,-14+LOX1,-14+LOX1,-13+LOX1,-13+LOX1,-12+LOX1,-12+LOX1,-11+LOX1,-11+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,-15+LOX1,-15+LOX1,-14+LOX1,-14+LOX1,-13+LOX1,-13+LOX1,-12+LOX1,-12+LOX1,-11+LOX1,-11+LOX1,-10+LOX1,-10+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,-14+LOX1,-14+LOX1,-13+LOX1,-13+LOX1,-12+LOX1,-12+LOX1,-12+LOX1,-11+LOX1,-11+LOX1,-10+LOX1,-10+LOX1,-9+LOX1,-9+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,-13+LOX1,-13+LOX1,-12+LOX1,-12+LOX1,-11+LOX1,-11+LOX1,-11+LOX1,-10+LOX1,-10+LOX1,-10+LOX1,-9+LOX1,-9+LOX1,-8+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,-12+LOX1,-12+LOX1,-11+LOX1,-11+LOX1,-11+LOX1,-10+LOX1,-10+LOX1,-10+LOX1,-9+LOX1,-9+LOX1,-8+LOX1,-8+LOX1,-8+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,-11+LOX1,-11+LOX1,-10+LOX1,-10+LOX1,-10+LOX1,-9+LOX1,-9+LOX1,-9+LOX1,-8+LOX1,-8+LOX1,-8+LOX1,-7+LOX1,-7+LOX1,0,0,0,0,0},
	{0,0,0,0,0,-10+LOX1,-10+LOX1,-9+LOX1,-9+LOX1,-9+LOX1,-9+LOX1,-8+LOX1,-8+LOX1,-8+LOX1,-7+LOX1,-7+LOX1,-7+LOX1,-7+LOX1,-6+LOX1,0,0,0,0,0},
	{0,0,0,0,0,-9+LOX1,-9+LOX1,-8+LOX1,-8+LOX1,-8+LOX1,-8+LOX1,-7+LOX1,-7+LOX1,-7+LOX1,-7+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,0,0,0,0,0},
	{0,0,0,0,0,-8+LOX1,-8+LOX1,-8+LOX1,-7+LOX1,-7+LOX1,-7+LOX1,-7+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,0,0,0,0,0},
	{0,0,0,0,0,-7+LOX1,-7+LOX1,-7+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-4+LOX1,0,0,0,0,0},
	{0,0,0,0,-6+LOX1,-6+LOX1,-6+LOX1,-6+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,0,0,0,0,0},
	{0,0,0,0,-5+LOX1,-5+LOX1,-5+LOX1,-5+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,0,0,0,0,0},
	{0,0,0,0,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-4+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-2+LOX1,0,0,0,0,0},
	{0,0,0,0,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-3+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,0,0,0,0,0},
	{0,0,0,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-2+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,0,0,0,0,0},
	{0,0,0,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,-1+LOX1,0,0,0,0,0},
	{0,0,0,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0+LOX1,0,0,0,0,0},
	{0,0,0,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,0,0,0,0,0},
	{0,0,0,0,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,1+LOX1,0,0,0,0,0},
	{0,0,0,0,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,2+LOX1,0,0,0,0,0},
	{0,0,0,0,4+LOX1,4+LOX1,4+LOX1,4+LOX1,4+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,2+LOX1,0,0,0,0,0},
	{0,0,0,0,5+LOX1,5+LOX1,5+LOX1,5+LOX1,4+LOX1,4+LOX1,4+LOX1,4+LOX1,4+LOX1,4+LOX1,4+LOX1,3+LOX1,3+LOX1,3+LOX1,3+LOX1,0,0,0,0,0},
	{0,0,0,0,0,6+LOX1,6+LOX1,6+LOX1,5+LOX1,5+LOX1,5+LOX1,5+LOX1,5+LOX1,5+LOX1,4+LOX1,4+LOX1,4+LOX1,4+LOX1,4+LOX1,0,0,0,0,0},
	{0,0,0,0,0,7+LOX1,7+LOX1,7+LOX1,6+LOX1,6+LOX1,6+LOX1,6+LOX1,6+LOX1,5+LOX1,5+LOX1,5+LOX1,5+LOX1,5+LOX1,4+LOX1,0,0,0,0,0},
	{0,0,0,0,0,8+LOX1,8+LOX1,8+LOX1,7+LOX1,7+LOX1,7+LOX1,7+LOX1,6+LOX1,6+LOX1,6+LOX1,6+LOX1,5+LOX1,5+LOX1,5+LOX1,0,0,0,0,0},
	{0,0,0,0,0,9+LOX1,9+LOX1,8+LOX1,8+LOX1,8+LOX1,8+LOX1,7+LOX1,7+LOX1,7+LOX1,7+LOX1,6+LOX1,6+LOX1,6+LOX1,6+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,10+LOX1,10+LOX1,9+LOX1,9+LOX1,9+LOX1,9+LOX1,8+LOX1,8+LOX1,8+LOX1,7+LOX1,7+LOX1,7+LOX1,6+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,11+LOX1,11+LOX1,10+LOX1,10+LOX1,10+LOX1,9+LOX1,9+LOX1,9+LOX1,8+LOX1,8+LOX1,8+LOX1,7+LOX1,7+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,12+LOX1,12+LOX1,11+LOX1,11+LOX1,11+LOX1,10+LOX1,10+LOX1,10+LOX1,9+LOX1,9+LOX1,8+LOX1,8+LOX1,8+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,13+LOX1,13+LOX1,12+LOX1,12+LOX1,11+LOX1,11+LOX1,11+LOX1,10+LOX1,10+LOX1,10+LOX1,9+LOX1,9+LOX1,8+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,14+LOX1,14+LOX1,13+LOX1,13+LOX1,12+LOX1,12+LOX1,11+LOX1,11+LOX1,11+LOX1,10+LOX1,10+LOX1,9+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,15+LOX1,15+LOX1,14+LOX1,14+LOX1,13+LOX1,13+LOX1,12+LOX1,12+LOX1,11+LOX1,11+LOX1,10+LOX1,10+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,16+LOX1,16+LOX1,15+LOX1,15+LOX1,14+LOX1,14+LOX1,13+LOX1,13+LOX1,12+LOX1,12+LOX1,11+LOX1,11+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,17+LOX1,16+LOX1,16+LOX1,15+LOX1,15+LOX1,14+LOX1,14+LOX1,13+LOX1,13+LOX1,12+LOX1,12+LOX1,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,18+LOX1,17+LOX1,17+LOX1,16+LOX1,16+LOX1,15+LOX1,15+LOX1,14+LOX1,14+LOX1,13+LOX1,12+LOX1,0,0,0,0,0}};


const unsigned char	Ascii_4x7[10][4] = {
					{ 0x7c,0x82,0x82,0x7c },	/* 0 */
					{ 0x00,0x04,0xfe,0x00 },	/* 1 */
					{ 0xc4,0xa2,0x92,0x8c },	/* 2 */
					{ 0x44,0x92,0x92,0x6c },	/* 3 */
					{ 0x60,0x58,0x46,0xfe },	/* 4 */
					{ 0x4e,0x8a,0x8a,0x72 },	/* 5 */
					{ 0x7c,0x92,0x92,0x64 },	/* 6 */
					{ 0x02,0xe2,0x1a,0x06 },	/* 7 */
					{ 0x6c,0x92,0x92,0x6c },	/* 8 */
					{ 0x4c,0x92,0x92,0x7c }};	/* 9 */



#if 0				/* 7K */
#if REVERS == 0
const unsigned	char	PAL[8][7] = {
	{0,0,0,0,0,0,0},
	{1,0,0,0,0,0,0},
	{0,1,0,0,1,0,0},
	{1,0,1,0,0,1,0},
	{0,1,0,1,0,1,1},
	{1,1,0,1,1,0,1},
	{1,1,1,0,1,1,1},
	{1,1,1,1,1,1,1}};
#else
const unsigned	char	PAL[8][7] = {
	{1,1,1,1,1,1,1},
	{0,1,1,1,1,1,1},
	{1,0,1,1,0,1,1},
	{0,1,0,1,1,0,1},
	{1,0,1,0,1,0,0},
	{0,0,1,0,0,1,0},
	{0,0,0,1,0,0,0},
	{0,0,0,0,0,0,0}};
#endif

const unsigned	char	PAL_White[8][7] = {
	{0,0,0,0,0,0,0},
	{1,0,0,0,0,0,0},
	{0,1,0,0,1,0,0},
	{1,0,1,0,0,1,0},
	{0,1,0,1,0,1,1},
	{1,1,0,1,1,0,1},
	{1,1,1,0,1,1,1},
	{1,1,1,1,1,1,1}};


#else									/* 4K */
#if REVERS == 0
const unsigned	char	PAL[8][7] = {
	{0,0,0,0,0,0,0},
	{0,1,0,0,1,0,0},
	{0,1,0,0,1,0,0},
	{0,1,0,1,0,1,1},
	{0,1,0,1,0,1,1},
	{0,1,0,1,0,1,1},
	{1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1}};
#else
const unsigned	char	PAL[8][7] = {
	{1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1},
	{1,0,1,1,0,1,1},
	{1,0,1,1,0,1,1},
	{1,0,1,0,0,1,0},
	{1,0,1,0,0,1,0},
	{0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0}};
#endif

const unsigned	char	PAL_White[8][7] = {
	{0,0,0,0,0,0,0},
	{0,1,0,0,1,0,0},
	{0,1,0,0,1,0,0},
	{0,1,0,1,0,1,1},
	{0,1,0,1,0,1,1},
	{0,1,0,1,0,1,1},
	{1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1}};
#endif


const unsigned	char	cBIT[8] = { 0x80,0xc0,0xe0,0xf0,0xf8,0xfc,0xfe,0xff};


unsigned int iD_CNT = 0;
int iLEV_R = 0;
int iLEV_L = 30;
int iLEV_R_hensa = 0;
int iLEV_L_hensa = 0;

unsigned char	LCD_DATA[64];
unsigned char	VOL_DATA[8][6];
unsigned char	VOL_C_DATA[18];

void Set_Volume_data( int iVol,int cn );

/********************************************************************/
/*																	*/
/*			Disp_Peak_Meter											*/
/*						AiO[^[\						*/
/*																	*/
/*				V̎ŃOf[V\̈				*/
/*				ωƂ~bcallKv܂B		*/
/*																	*/
/*				ilevel_R	͈(0-99)								*/
/*				ilevel_L	͈(0-99)								*/
/*				iVol		͈(0-999)								*/
/*																	*/
/*																	*/
/********************************************************************/

void Disp_Peak_Meter( int ilevel_R, int ilevel_L ,int iVol )
{

	int	i,j,cn,iw,pos,ilw,ilL,ilR,wrl;
	unsigned	char	cdat;

	cn = iD_CNT % 7;
	iD_CNT++;

#if 1
	if( iVol > 999 ) iVol = 999;
#else
	if( iVol > 99 ) iVol = 99;
#endif
	if( iVol < 0 ) iVol = 0;

	Set_Volume_data( iVol , cn );					/* {[xf[^Zbg */

#if 0
	iLEV_R_hensa += ilevel_R - iLEV_R;
	iLEV_L_hensa += ilevel_L - iLEV_L;

	if( cn & 0x01 ){
		if( iLEV_R_hensa > 0 ){					/* オƂ͑AƂ͒x */
			iLEV_R += (iLEV_R_hensa / 14);
			iLEV_R_hensa -= (iLEV_R_hensa / 7);
		} else {
			iLEV_R += (iLEV_R_hensa / 28);
			iLEV_R_hensa += -(iLEV_R_hensa / 14);
		}
		if( iLEV_L_hensa > 0 ){
			iLEV_L += (iLEV_L_hensa / 14);
			iLEV_L_hensa -= (iLEV_L_hensa / 7);
		} else {
			iLEV_L += (iLEV_L_hensa / 28);
			iLEV_L_hensa += -(iLEV_L_hensa / 14);
		}
	}
#endif
	iLEV_R = ilevel_R;
	iLEV_L = ilevel_L;

	ilL = iLEV_L * 38 / 100 ;
	ilR = iLEV_R * 38 / 100 ;

	if(	ilL > 37){				/* Level Over */
		ilL = 37;				/* Set MAX */
	}
	if(	ilR > 37){				/* Level Over */
		ilR = 37;				/* Set MAX */
	}
	if(	ilL < 0){				/* Level Over */
		ilL = 0;				/* Set 0 */
	}
	if(	ilR < 0){				/* Level Over */
		ilR = 0;				/* Set 0 */
	}

	for( i = 0 ; i < 8 ; i++ ){
		if( i & 1 ){
			ilw = ilR;
			wrl = 5;
		} else {
			ilw = ilL;
			wrl = 0;
		}
		pos = MSX1;
		for(j=0;j<PM_Width;j++ ,pos++){
			iw = ((i>>1)*8);
			cdat  = PAL[Peak_meter[iw+7][j]][cn];
			cdat <<= 1;
			cdat |= PAL[Peak_meter[iw+6][j]][cn];
			cdat <<= 1;
			cdat |= PAL[Peak_meter[iw+5][j]][cn];
			cdat <<= 1;
			cdat |= PAL[Peak_meter[iw+4][j]][cn];
			cdat <<= 1;
			cdat |= PAL[Peak_meter[iw+3][j]][cn];
			cdat <<= 1;
			cdat |= PAL[Peak_meter[iw+2][j]][cn];
			cdat <<= 1;
			cdat |= PAL[Peak_meter[iw+1][j]][cn];
			cdat <<= 1;
			cdat |= PAL[Peak_meter[iw+0][j]][cn];

			if( (i > 1) && ( pos != 0 )){
				iw = (( i - 2 ) >> 1) * 8;
#if REVERS == 0
				cdat &= (PM_LEVEL[ilw][iw+7] == pos)? 0x7f:0xff;
				cdat &= (PM_LEVEL[ilw][iw+6] == pos)? 0xbf:0xff;
				cdat &= (PM_LEVEL[ilw][iw+5] == pos)? 0xdf:0xff;
				cdat &= (PM_LEVEL[ilw][iw+4] == pos)? 0xef:0xff;
				cdat &= (PM_LEVEL[ilw][iw+3] == pos)? 0xf7:0xff;
				cdat &= (PM_LEVEL[ilw][iw+2] == pos)? 0xfb:0xff;
				cdat &= (PM_LEVEL[ilw][iw+1] == pos)? 0xfd:0xff;
				cdat &= (PM_LEVEL[ilw][iw+0] == pos)? 0xfe:0xff;

#else
				cdat |= (PM_LEVEL[ilw][iw+7] == pos)? 0x80:0x00;
				cdat |= (PM_LEVEL[ilw][iw+6] == pos)? 0x40:0x00;
				cdat |= (PM_LEVEL[ilw][iw+5] == pos)? 0x20:0x00;
				cdat |= (PM_LEVEL[ilw][iw+4] == pos)? 0x10:0x00;
				cdat |= (PM_LEVEL[ilw][iw+3] == pos)? 0x08:0x00;
				cdat |= (PM_LEVEL[ilw][iw+2] == pos)? 0x04:0x00;
				cdat |= (PM_LEVEL[ilw][iw+1] == pos)? 0x02:0x00;
				cdat |= (PM_LEVEL[ilw][iw+0] == pos)? 0x01:0x00;
#endif
			}
			LCD_DATA[j+wrl] = cdat;
		}
		if( i & 1 ){

				GrLCD_PSET(1,(i>>1),MSX1);
/*				LCD_PSET1_ASM((unsigned short)(i>>1),MSX1+5);	*/

				if( i == 1 ){
					LCD_DATA[0] = VOL_C_DATA[8];
					LCD_DATA[1] = VOL_C_DATA[9];
					LCD_DATA[2] = VOL_C_DATA[10];
					LCD_DATA[3] = VOL_C_DATA[11];
					LCD_DATA[4] = VOL_C_DATA[12];
					LCD_DATA[5] = VOL_C_DATA[13];
					LCD_DATA[6] = VOL_C_DATA[14];
					LCD_DATA[7] = VOL_C_DATA[15];
/*					LCD_DATA[8] = 0x00;						*/

				} else {

					LCD_DATA[0] = VOL_DATA[i][0];
					LCD_DATA[1] = VOL_DATA[i][1];
					LCD_DATA[2] = VOL_DATA[i][2];
					LCD_DATA[3] = VOL_DATA[i][3];
					LCD_DATA[4] = VOL_DATA[i][4];
				}

				LCD_D1_ASM(PM_Width+5,&LCD_DATA[0]);				/* R */
				GrLCD_END(1);

			} else {

				GrLCD_PSET(0,(i>>1),MSX1);
/*				LCD_PSET0_ASM((unsigned short)(i>>1),MSX1);		*/

				if( i == 0 ){
					LCD_DATA[53] = VOL_C_DATA[0];
					LCD_DATA[54] = VOL_C_DATA[1];
					LCD_DATA[55] = VOL_C_DATA[2];
					LCD_DATA[56] = VOL_C_DATA[3];
					LCD_DATA[57] = VOL_C_DATA[4];
					LCD_DATA[58] = VOL_C_DATA[5];
					LCD_DATA[59] = VOL_C_DATA[6];
					LCD_DATA[60] = VOL_C_DATA[7];

				} else {
					LCD_DATA[PM_Width] = VOL_DATA[i][0];
					LCD_DATA[PM_Width+1] = VOL_DATA[i][1];
					LCD_DATA[PM_Width+2] = VOL_DATA[i][2];
					LCD_DATA[PM_Width+3] = VOL_DATA[i][3];
					LCD_DATA[PM_Width+4] = VOL_DATA[i][4];
				}

				LCD_D0_ASM(PM_Width+5,&LCD_DATA[0]);					/* L */
				GrLCD_END(0);
			}
		

	}
}


/* }X^[{[@OOO|XXX\ 	*/
/* }X^[{[x\ 		*/

void Set_Volume_data( int iVol, int cn )
{

	int	i,j,k,iw;
	unsigned	char	cdat,clev[6];

#if 1
/* }X^[{[@OO|XXX\ 	*/
	i = iVol/100;
	j = (iVol/10)%10;
	k = iVol%10;

#if REVERS == 0
	VOL_C_DATA[0]  = 0x81;						/* l̃hbg */
	VOL_C_DATA[15] = 0x81;
#else
	VOL_C_DATA[0]  = 0x01;
	VOL_C_DATA[15] = 0x01;
#endif

	VOL_C_DATA[1] = Ascii_4x7[i][0];		/* 0-9 */
	VOL_C_DATA[2] = Ascii_4x7[i][1];
	VOL_C_DATA[3] = Ascii_4x7[i][2];
	VOL_C_DATA[4] = Ascii_4x7[i][3];

	VOL_C_DATA[5] = 0x00;

	VOL_C_DATA[6] = Ascii_4x7[j][0];		/* 0-9 */
	VOL_C_DATA[7] = Ascii_4x7[j][1];
	VOL_C_DATA[8] = Ascii_4x7[j][2];
	VOL_C_DATA[9] = Ascii_4x7[j][3];

	VOL_C_DATA[10] = 0x80;

	VOL_C_DATA[11] = Ascii_4x7[k][0];		/* 0-9 */
	VOL_C_DATA[12] = Ascii_4x7[k][1];
	VOL_C_DATA[13] = Ascii_4x7[k][2];
	VOL_C_DATA[14] = Ascii_4x7[k][3];

	/* }X^[{[x\ */

	i = (iVol * 24)/ 1000;

#else

/* }X^[{[@OO|XX\ 	*/
	i = iVol/10;
	j = iVol%10;

#if REVERS == 0
	VOL_DATA[0][0] = 0x01;						/* l̃hbg */
	VOL_DATA[1][4] = 0x01;
#else
	VOL_DATA[0][0] = ~(0xfe);
	VOL_DATA[1][4] = ~(0xfe);
#endif

	VOL_DATA[0][1] = Ascii_4x7[i][0];		/* L */
	VOL_DATA[0][2] = Ascii_4x7[i][1];
	VOL_DATA[0][3] = Ascii_4x7[i][2];
	VOL_DATA[0][4] = Ascii_4x7[i][3];

	VOL_DATA[1][0] = Ascii_4x7[j][0];		/* R */
	VOL_DATA[1][1] = Ascii_4x7[j][1];
	VOL_DATA[1][2] = Ascii_4x7[j][2];
	VOL_DATA[1][3] = Ascii_4x7[j][3];

	/* }X^[{[x\ */

	i = (iVol * 24)/ 100;

#endif

	if( i >= 16 ){
		clev[0] = cBIT[i-16];
		clev[1] = 0xff;
		clev[2] = 0xff;
	} else 
	if( i >= 8 ){
		clev[0] = 0;
		clev[1] = cBIT[i-8];
		clev[2] = 0xff;
	} else {
		clev[0] = 0;
		clev[1] = 0;
		clev[2] = cBIT[i];
	}

	for( i = 2 ; i < 8 ; i++ ){
		if( i & 1 ){
			iw = 5;
		} else {
			iw = 0;
		}
		k = (((i-2)>>1)*8);
		for( j = 0 ; j < 6 ; j++,iw++){
			cdat  = PAL_White[Vol_meter[k+7][iw]][cn];
			cdat <<= 1;
			cdat |= PAL_White[Vol_meter[k+6][iw]][cn];
			cdat <<= 1;
			cdat |= PAL_White[Vol_meter[k+5][iw]][cn];
			cdat <<= 1;
			cdat |= PAL_White[Vol_meter[k+4][iw]][cn];
			cdat <<= 1;
			cdat |= PAL_White[Vol_meter[k+3][iw]][cn];
			cdat <<= 1;
			cdat |= PAL_White[Vol_meter[k+2][iw]][cn];
			cdat <<= 1;
			cdat |= PAL_White[Vol_meter[k+1][iw]][cn];
			cdat <<= 1;
			cdat |= PAL_White[Vol_meter[k][iw]][cn];

			if( i & 1 ){
				if( j < 3){
					cdat = (cdat ^ clev[k>>3]);
				}
				VOL_DATA[i][j] = cdat;
			} else {
				if( j > 1){
					cdat = (cdat ^ clev[k>>3]);
				}
				VOL_DATA[i][j] = cdat;
			}
		}
	}

}

